; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
GLYPHMETRICSFLOAT STRUCT
	gmfBlackBoxX dd ?
	gmfBlackBoxY dd ?
	x	     dd ?
	y	     dd ?
	gmfCellIncX  dd ?
	gmfCellIncY  dd ?
GLYPHMETRICSFLOAT ENDS
Vector3D struct
	x dd ?; the x value of this Vector3D
	y dd ?; the y value of this Vector3D
	z dd ?; the z value of this Vector3D
Vector3D ends
GMFSIZE EQU SIZEOF GLYPHMETRICSFLOAT
ConstantVelocity struct
	pos Vector3D <>
	vel Vector3D <>
ConstantVelocity ends
MotionUnderGravitation struct
	pos Vector3D <>
	vel Vector3D <>
MotionUnderGravitation ends
MassConnectedWithSpring struct
	pos Vector3D <>
	vel Vector3D <>
MassConnectedWithSpring ends
ANTIALIASED_QUALITY = 4
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	x:dword
local	y:dword
local	dt_:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT               
	cmp	edx,WM_TIMER          
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmKEYDOWN:cmp	r8b,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	glDeleteLists,base,256; delete all 256 characters
	mov	ecx,gmf
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movss	xmm0,const0_025;dt = milliseconds/1000 Let's Convert Milliseconds To Seconds
	divss	xmm0,slowMotionRatio
	movss	dt_,xmm0;dt /= slowMotionRatio; divide dt by slowMotionRatio and obtain the new dt
	movss	xmm1,timeElapsed
	addss	xmm1,xmm0
	movss	timeElapsed,xmm1;timeElapsed += dt; Iterate Elapsed Time
;------------------------------------------------------------------
	mov	eax,offset constantVelocity
	movss	xmm0,[rax].ConstantVelocity.pos.x
	movss	xmm1,dt_
	mulss	xmm1,const10
	addss	xmm0,xmm1
	movss	[rax].ConstantVelocity.pos.x,xmm0
;------------------------------------------------------------------
	movss	xmm0,Gravity
	addss	xmm0,const0_001
	movss	Gravity,xmm0
	mov	eax,offset motionUnderGravitation
	movss	xmm0,[rax].ConstantVelocity.pos.x
	addss	xmm0,const0_05
	movss	[rax].ConstantVelocity.pos.x,xmm0

	movss	xmm0,[rax].ConstantVelocity.pos.y
	addss	xmm0,const0_16;xmm1
	subss	xmm0,Gravity
	movss	[rax].ConstantVelocity.pos.y,xmm0
;------------------------------------------------------------------
	movss	xmm0,timeElapsed
	invoke	sinf
	mulss	xmm0,const0_025
	mov	eax,offset massConnectedWithSpring
	movss	xmm1,[rax].ConstantVelocity.pos.x
	addss	xmm1,xmm0
	movss	[rax].ConstantVelocity.pos.x,xmm1
;------------------------------------------------------------------
	invoke	InvalidateRect,hWin,0,0
	jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
 	invoke	GlobalAlloc,sizeof GPTR,GLYPHMETRICSFLOAT*256
 	mov	gmf, eax 
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; Black Background
	invoke	glShadeModel,GL_SMOOTH; Select Smooth Shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set Perspective Calculations To Most Accurate
	invoke	BuildFont; Build The Font
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0, 0; Reset The Current Viewport
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity; Reset The Projection Matrix
	movsd	xmm3,constd100
	movsd	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movsd	xmm0,constd45
	invoke	gluPerspective; Calculate The Aspect Ratio Of The Window
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity ; Reset The Modelview Matrix
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene   Our Drawing Routine
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	invoke	glMatrixMode,GL_MODELVIEW;
	invoke	glLoadIdentity; Reset The Modelview Matrix
	
; Position Camera 40 Meters Up In Z-Direction.
; Set The Up Vector In Y-Direction So That +X Directs To Right And +Y Directs To Up On The Window.
	xor	eax,eax
	mov	[rsp+40h],rax
	mov	[rsp+30h],rax
	mov	[rsp+28h],rax
	mov	[rsp+20h],rax
	mov	rax,constd1
	mov	[rsp+38h],rax
	xorps	xmm3,xmm3
	movsd	xmm2,constd40
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	gluLookAt;,,,,,rbx,rbx,rbx,constd1,rbx
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
; Drawing The Coordinate Plane Starts Here.
; We Will Draw Horizontal And Vertical Lines With A Space Of 1 Meter Between Them.
	invoke	glColor3ub,0,0,255; Draw In Blue
	invoke	glBegin,GL_LINES	
; Draw The Vertical Lines
	movss	xmm0,const_20
	movss	x,xmm0
	mov	edi,41
;	for (float x = -20; x <= 20; x += 1.0f); x += 1.0f Stands For 1 Meter Of Space In This Example
@@:	xorps	xmm2,xmm2
	movss	xmm1,const20
	invoke	glVertex3f;x, 20, 0
	xorps	xmm2,xmm2
	movss	xmm1,const_20
	movss	xmm0,x
	invoke	glVertex3f;x,-20, 0
	movss	xmm0,x
	addss	xmm0,const1
	movss	x,xmm0
	dec	edi
	jnz	@b
; Draw The Horizontal Lines
	movss	xmm1,const_20
	movss	y,xmm1
	mov	edi,41
;	for (float y = -20; y <= 20; y += 1.0f); y += 1.0f Stands For 1 Meter Of Space In This Example
@@:	xorps	xmm2,xmm2
	movss	xmm0,const20	
	invoke	glVertex3f;( 20, y, 0);
	xorps	xmm2,xmm2
	movss	xmm1,y
	movss	xmm0,const_20	
	invoke	glVertex3f;-20, y, 0
	movss	xmm1,y
	addss	xmm1,const1
	movss	y,xmm1
	dec	edi
	jnz	@b
	invoke	glEnd

; Drawing The Coordinate Plane Ends Here.
; Draw All Masses In constantVelocity Simulation (Actually There Is Only One Mass In This Example Of Code)

	invoke	glColor3ub,255,0,0; Draw In Red
	mov	r9d,offset fmt3
        mov	eax,offset constantVelocity
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	addss	xmm1,const1
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glPrint;,pos->x, pos->y + 1, pos->z
        movss	xmm0,const4
	invoke	glPointSize;(4);
	invoke	glBegin,GL_POINTS;
        mov	eax,offset constantVelocity
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glVertex3f;(pos->x, pos->y, pos->z);
	invoke	glEnd
; Drawing Masses In constantVelocity Simulation Ends Here.

; Draw All Masses In motionUnderGravitation Simulation (Actually There Is Only One Mass In This Example Of Code)
	invoke	glColor3ub,255,255,0; Draw In Yellow
	mov	r9d,offset fmt4
        mov	eax,offset motionUnderGravitation
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	addss	xmm1,const1
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glPrint;,pos->x, pos->y + 1, pos->z
	movss	xmm0,const4 
	invoke	glPointSize;(4);
	invoke	glBegin,GL_POINTS
        mov	eax,offset motionUnderGravitation
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glVertex3f;(pos->x, pos->y, pos->z);
	invoke	glEnd
; Drawing Masses In motionUnderGravitation Simulation Ends Here.

; Draw All Masses In massConnectedWithSpring Simulation (Actually There Is Only One Mass In This Example Of Code)
	invoke	glColor3ub,0,255,0; Draw In Green
	mov	r9d,offset fmt5
        mov	eax,offset massConnectedWithSpring
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	addss	xmm1,const1
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glPrint;,pos->x, pos->y + 1, pos->z
	movss	xmm0,const8
	invoke	glPointSize;(8);
	invoke	glBegin,GL_POINTS
        mov	eax,offset massConnectedWithSpring
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glVertex3f;(pos->x, pos->y, pos->z);
	invoke	glEnd
; Draw A Line From The Mass Position To Connection Position To Represent The Spring
	invoke	glBegin,GL_LINES
	xorps	xmm2,xmm2
	movss	xmm1,const_5
	xorps	xmm0,xmm0
	invoke	glVertex3f
;			
        mov	eax,offset massConnectedWithSpring
	movss	xmm2,[rax].ConstantVelocity.pos.z
	movss	xmm1,[rax].ConstantVelocity.pos.y
	movss	xmm0,[rax].ConstantVelocity.pos.x
	invoke	glVertex3f;(pos->x, pos->y, pos->z);
	invoke	glEnd
; Drawing masses in massConnectedWithSpring simulation ends here.
	invoke	glColor3ub,255, 255, 255; draw in white
	cvtss2sd xmm0,timeElapsed
	movq	qword ptr [rsp+20h],xmm0
	mov	r9d,offset fmt1	
	xorps	xmm2,xmm2
	movss	xmm1,const14
	movss	xmm0,const_5
	invoke	glPrint; Print timeElapsed

	cvtss2sd xmm0,slowMotionRatio
	movq	qword ptr [rsp+20h],xmm0
	mov	r9d,offset fmt2
	xorps	xmm2,xmm2
	movss	xmm1,const13
	movss	xmm0,const_5
	invoke	glPrint; Print slowMotionRatio
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
BuildFont proc; Build Our Bitmap Font
local   font:HFONT	; Windows Font ID
local   oldfont:HFONT

	invoke	glGenLists,256; Storage For 256 Characters
	mov	base,rax
	xor	edx,edx
	push	rdx
	push	rdx;FF_DONTCARE or DEFAULT_PITCH; family and pitch
	push	ANTIALIASED_QUALITY; Output Quality
	push	rdx;CLIP_DEFAULT_PRECIS; Clipping Precision
	push	OUT_TT_PRECIS	; Output Precision
	push	rdx;ANSI_CHARSET	; Character Set Identifier
	push	rdx;FALSE=Strikeout
	push	rdx;FALSE=Underline
	push	rdx;FALSE=Italic
	push	FW_BOLD; Font Weight
	mov	ecx,-12
	sub	esp,20h
	invoke	CreateFont,,,0,0; Orientation Angle
	mov	font,rax
	invoke	SelectObject,hDC,eax; Selects The Font We Created
        mov	oldfont,rax
	mov	eax,gmf; Address Of Buffer To Recieve Data
	mov	[rsp+38h],rax
	mov	qword ptr [rsp+30h],WGL_FONT_POLYGONS; use polygons, not lines
	xor	edx,edx
	mov	[rsp+28h],rdx;0.0	 Font Thickness In The Z Direction
	mov	[rsp+20h],rdx;0.0	 Deviation From The True Outlines
	invoke	wglUseFontOutlinesA,hDC,,255,base; Starting Display Lists
	invoke	SelectObject,hDC,oldfont
	invoke	DeleteObject,font
	leave
	ret
BuildFont endp
glPrint proc x:dword, y:dword, z:dword, fmt:dword, ap:qword; Custom GL "Print" Routine
local	text[256]:byte; Holds Our String
local	len:dword
local	length_:dword

	movd	x,xmm0
	movd	y,xmm1
	movd	z,xmm2
	mov	fmt,r9d
	or	r9d,r9d
	jz	exit0;if fmt0 == NULL If There's No Text
	and	length_,0; Used To Find The Length Of The Text
; Parses The String For Variables
	lea	r8d,ap; Pointer To List Of Arguments
	mov	edx,fmt
	lea	ecx,text
	invoke	vsprintf; And Converts Symbols To Actual Numbers
        mov	len,eax
	dec	eax
	xorps	xmm1,xmm1; Results Are Stored In Text
	mov	esi,eax;len
        lea	eax,text
	mov	edx,gmf
@@:	movzx	ecx,byte ptr [rsi+rax]
	imul	ecx,GMFSIZE
	addss	xmm1,[rdx+rcx].GLYPHMETRICSFLOAT.gmfCellIncX
	dec	esi
	jns	@b
	movss	xmm0,x
	subss	xmm0,xmm1;length_
	movss	xmm2,z
	movss	xmm1,y
	invoke	glTranslatef;(x0 - length_, y0, z0) position text on the screen
	invoke	glPushAttrib,GL_LIST_BIT; Pushes The Display List Bits
	invoke	glListBase,base; Sets The Base Character to 0
	lea	r8d,text
	mov	ecx,len
	invoke	glCallLists,,GL_UNSIGNED_BYTE; Draws The Display List Text
	invoke	glPopAttrib; Pops The Display List Bits
	xorps	xmm2,xmm2
	subss	xmm2,z
	xorps	xmm1,xmm1
	subss	xmm1,y
	xorps	xmm0,xmm0
	subss	xmm0,x
	invoke	glTranslatef;(-x, -y, -z); Position Text On The Screen
exit0:	leave
	ret
glPrint endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

FileName	db "br_Rabbit3.cur",0
szClassName	db "NeHe lesson#39: Physics Tutorial",0
slowMotionRatio dd 10.0; slowMotionRatio Is A Value To Slow Down The Simulation, Relative To Real World Time
timeElapsed dd 0; Elapsed Time In The Simulation (Not Equal To Real World's Time Unless slowMotionRatio Is 1
fmt1	db "Time elapsed (seconds): %.2f",0
fmt2	db "Slow motion ratio: %.2f",0
fmt3	db "Mass with constant vel",0
fmt4	db "Motion under gravitation",0
fmt5	db "Mass connected with spring",0
base	dq ?; Base Display List For The Font Set
gmf	dd ?; Storage For Information About Our Outline Font Characters
maxPossible_dt dd 0.1; Say That The Maximum Possible dt Is 0.1 Seconds
constantVelocity	ConstantVelocity  <{0,0,0},{1.0,0,0}>
motionUnderGravitation	MotionUnderGravitation <{-10.0, 0, 0},{10.0, 15.0, 0}>
Gravity		dd 0
massConnectedWithSpring	MassConnectedWithSpring <{-10.0, -5.0, 0},{0,0,0}>
;float
const0_001	dd 0.001
const0_025 	dd 0.025
const0_05	dd 0.05
const0_16	dd 0.16
const0_5	dd 0.5
const1		dd 1.0
const4		dd 4.0
const_5		dd -5.0
const8		dd 8.0
const10		dd 10.0
const13		dd 13.0
const14		dd 14.0
const20		dd 20.0
const_20	dd -20.0
;double
constd1		dq 1.0
constd40	dq 40.0
constd45	dq 45.0
constd100	dq 100.0
end